/*
 *
 *                   _/_/_/    _/_/   _/    _/ _/_/_/    _/_/
 *                  _/   _/ _/    _/ _/_/  _/ _/   _/ _/    _/
 *                 _/_/_/  _/_/_/_/ _/  _/_/ _/   _/ _/_/_/_/
 *                _/      _/    _/ _/    _/ _/   _/ _/    _/
 *               _/      _/    _/ _/    _/ _/_/_/  _/    _/
 *
 *             ***********************************************
 *                              PandA Project 
 *                     URL: http://panda.dei.polimi.it
 *                       Politecnico di Milano - DEIB
 *                        System Architectures Group
 *             ***********************************************
 *              Copyright (c) 2004-2016 Politecnico di Milano
 *
 *   This file is part of the PandA framework.
 *
 *   The PandA framework is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
/**
 * @file copyrights_strings.hpp
 * @brief It collects all the commont strings covering PandA copyrights issues.
 *
 * @author Fabrizio Ferrandi <fabrizio.ferrandi@polimi.it>
 * $Revision$
 * $Date$
 * Last modified by $Author$
 *
*/
#ifndef COPYRIGHT_STRINGS_HPP
#define COPYRIGHT_STRINGS_HPP

#define GENERATED_COPYRIGHT "This component has been derived from the input source code ans so it does not fall under the copyright of "\
"PandA framwework, but it follows the input source code copyright, and may be aggregated with components of "\
"the BAMBU/PANDA IP LIBRARY."

#define GENERATED_LICENSE "THIS COMPONENT IS PROVIDED \"AS IS\" AND WITHOUT ANY EXPRESS OR IMPLIED "\
"WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF "\
"MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE."


#define COPYING3_SHORT_NROW 17
#define COPYING3_SHORT_MACRO \
static const char* COPYING3_SHORT[COPYING3_SHORT_NROW] = {\
    "************************************************************************\n",\
    "The following text holds for all the components tagged with PANDA_LGPLv3.\n",\
    "They are all part of the BAMBU/PANDA IP LIBRARY.\n",\
    "This library is free software; you can redistribute it and/or\n",\
    "modify it under the terms of the GNU Lesser General Public\n",\
    "License as published by the Free Software Foundation; either\n",\
    "version 3 of the License, or (at your option) any later version.\n",\
    "\n",\
    "This library is distributed in the hope that it will be useful,\n",\
    "but WITHOUT ANY WARRANTY; without even the implied warranty of\n",\
    "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n",\
    "Lesser General Public License for more details.\n",\
    "\n",\
    "You should have received a copy of the GNU Lesser General Public\n",\
    "License along with the PandA framework; see the files COPYING.LIB\n",\
    "If not, see <http://www.gnu.org/licenses/>.\n",\
    "************************************************************************\n\n"\
};

#endif
