/*
 *
 *                   _/_/_/    _/_/   _/    _/ _/_/_/    _/_/
 *                  _/   _/ _/    _/ _/_/  _/ _/   _/ _/    _/
 *                 _/_/_/  _/_/_/_/ _/  _/_/ _/   _/ _/_/_/_/
 *                _/      _/    _/ _/    _/ _/   _/ _/    _/
 *               _/      _/    _/ _/    _/ _/_/_/  _/    _/
 *
 *             ***********************************************
 *                              PandA Project 
 *                     URL: http://panda.dei.polimi.it
 *                       Politecnico di Milano - DEIB
 *                        System Architectures Group
 *             ***********************************************
 *              Copyright (c) 2004-2016 Politecnico di Milano
 *
 *   This file is part of the PandA framework.
 *
 *   The PandA framework is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
/**
 * @file graph_info.hpp
 * @brief Base class for graph property.
 *
 * @author Fabrizio Ferrandi <fabrizio.ferrandi@polimi.it>
 * @author Marco Lattuada <lattuada@elet.polimi.it>
 * $Revision$
 * $Date$
 * Last modified by $Author$
 *
*/
#ifndef GRAPH_INFO_HPP
#define GRAPH_INFO_HPP

#include <ostream>
#include "refcount.hpp"
/**
* @name forward declarations
*/
//@{
REF_FORWARD_DECL(GraphInfo);
//@}


/**
 * Base class storing user data information to the whole graph.
 * This class is associated with the graph data structure.
*/
struct GraphInfo
{
   /**
    * Constructor
    */
   GraphInfo()
   {}

   /// Destructor
   virtual ~GraphInfo(){}
};

/**
 * RefCount type definition of the GraphInfo class structure
*/
typedef refcount<GraphInfo> GraphInfoRef;
typedef refcount<const GraphInfo> GraphInfoConstRef;

#endif

